<?PHP

class BSReserveAccept extends BSCommon
{

	function main($_request, $_response)
	{
		global $ttem, $rb, $webappcfg;

		if (!isset($_request['reserveid']) || !is_numeric($_request['reserveid']))
		{
			$_response['result'] = xml_false;
			$_response['message'] = "MISSID";
			return;
		}

		$bssd = new BSReserveDetail();
		$bssd_res = $bssd->main(array("reserveid" => $_request['reserveid']), array());

		$exchangereserveobj = null;

		//print_r($bssd_res);
		if ($bssd_res['result'] == xml_false)
		{
			$_response['result'] = xml_false;
			$_response['message'] = "ERRORINLOADINGRESERVEDETAIL";
			return $_response;
		}
		else
			$exchangereserveobj = $bssd_res['sqldata']['exchangereservedb'][0];

		// Retrieve the Exchange Item
		//
		$bsse = new BSSimpleDetailExchange();
		$bsse_res = $bsse->main(array("id" => $exchangereserveobj->getpid()), array());

		$exchangeitemobj = null;
		if ($bsse_res['result'] == xml_true)
		{
			if ((isset($bsse_res['sqldata']) && isset($bsse_res['sqldata']['exchangeitemdb']))
				&& isset($bsse_res['sqldata']['exchangeitemdb'][0]))
			{
				$exchangeitemobj = $bsse_res['sqldata']['exchangeitemdb'][0];
				if ($exchangeitemobj->getstatus()!=ACTIVE)
				{
					$_response['result'] = xml_false;
					$_response['message'] = "EXCHANGE ITEM STATUS NOT ACTIVE";
					$_response['exchangeitem_id'] = $exchangeitemobj->getid();
					return $_response;
				}
			}
			else
			{
					$_response['result'] = xml_false;
					$_response['message'] = "SIMPLEDETAILEXCHANGE NO DATA";
					return $_response;
			}
		}
		else
		{
			$_response['result'] = xml_false;
			$_response['message'] = "SIMPLE DETAIL EXCHANGE FAIL";
			return $_response;
		}

		//echo("START TRANS<br />");
		$daour = new DAOUpdateReserve();
		if ($daour->starttransaction())
		{
			$daour_res = $daour->main(array(
				"userid" => $exchangereserveobj->getuserid(),
				"id" => $exchangeitemobj->getid()
			), array());


			if ($daour_res['result'] == xml_true)
			{
				$dao = new DAOReserveAccept();
				$dao_res = $dao->main(array("reserveid" => $exchangereserveobj->getid()),
					array());

				if ($dao_res['result']==xml_true)
				{
					$_response['result'] = xml_true;
					$_response['sqldata'] = $dao_res;
				}
				else
				{
					$_response['result'] = xml_false;
					$_response['message'] = "NORESULT";
				}
			}
			else
			{
				$_response['result'] = xml_false;
				$_response['message'] = "UPDATERESERVEFAIL";
			}

			if ($_response['result'] == xml_true)
			{
				$daour->commit();
			}
			else
			{
				$daour->rollback();
			}
		}
		else
		{
			$_response['result'] = xml_false;
			$_response['message'] = "CANNOT START TRANSACTION";
		}

		if ($exchangeitemobj != null)
			$_response['exchangeitem_id'] = $exchangeitemobj->getid();
		return $_response;
	}

}

?>
