<?PHP

class DAOCounter extends DAOControl
{

	function main($_request, $_response)
	{
		$sqlq = new SQLSelect();


		$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());

		$_response['x1db'] = $this->populate('x1db', $this->db_table['x1db'], $db_result);
		$_response['x2db'] = $this->populate('x2db', $this->db_table['x2db'], $db_result);
		$_response['x3db'] = $this->populate('x3db', $this->db_table['x3db'], $db_result);
		$_response['x4db'] = $this->populate('x4db', $this->db_table['x4db'], $db_result);

		return $_response;


	}

	function getcountbyforum($_request, $_response)
	{
		if (isset($_request['forumid']))
		{
			$sqlq = new SQLSelect();
			$sqlq->setSelect($this->db_field['uforum_messagedb'],
				$this->db_table['uforum_messagedb']);
			$sqlq->setWhere($this->db_table['uforum_messagedb'].
				".forumid=" . $_request['forumid']);
			$sqlq->setWhere($this->db_table['uforum_messagedb'].
				".status=" . ACTIVE);
			$sqlq->setWhere($this->db_table['uforum_messagedb'].
				".pmsgid=-1");
			$sqlq->setSelectOther("count(*) AS " . $this->db_table['uforum_messagedb']."count__msgcount");
			$sqlq->setGroup($this->db_table['uforum_messagedb'].
				".forumid");
			//echo("<p>" . $sqlq->SQLReturn() . "</p>");
			$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());


			if (isset($db_result['uforum_messagedbcount']))
			{
				if (count($db_result['uforum_messagedbcount'])>0)
				{
					return $db_result['uforum_messagedbcount'][0]['msgcount'];
				}
			}
			return 0;

		}
	}

	function getviewtimesbyforum($_request, $_response)
	{
		if (isset($_request['forumid']))
		{
			$sqlq = new SQLSelect();
			$sqlq->setSelect($this->db_field['uforum_messagedb'],
				$this->db_table['uforum_messagedb']);
			$sqlq->setWhere($this->db_table['uforum_messagedb'].
				".forumid=" . $_request['forumid']);

			$sqlq->setSelectOther("SUM(viewtimes) AS " . $this->db_table['uforum_messagedb']."count__viewtimes");
			$sqlq->setGroup($this->db_table['uforum_messagedb'].
				".forumid");
//echo($sqlq->SQLReturn());
			$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());

			if (isset($db_result['uforum_messagedbcount']))
			{
				if (count($db_result['uforum_messagedbcount'])>0)
				{
					return $db_result['uforum_messagedbcount'][0]['viewtimes'];
				}
			}
		}
		return 0;
	}

	function getcountbymsg($_request, $_response)
	{
		if (isset($_request['msgid']))
		{
			$sqlq = new SQLSelect();
			$sqlq->setSelect($this->db_field['uforum_messagedb'],
				$this->db_table['uforum_messagedb']);
			$sqlq->setWhere($this->db_table['uforum_messagedb'].
				".pmsgid=" . $_request['msgid']);
			$sqlq->setWhere($this->db_table['uforum_messagedb'].
				".status=" . ACTIVE);
			$sqlq->setSelectOther("count(*) AS " . $this->db_table['uforum_messagedb']."count__replycount");
			$sqlq->setGroup($this->db_table['uforum_messagedb'].
				".pmsgid");
//echo("<br />" . $sqlq->SQLReturn() . "<br />");
			$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());

//			echo("BEGIN");
//			print_r($db_result);
//			echo("END");
			if (isset($db_result['uforum_messagedbcount']))
			{
				if (count($db_result['uforum_messagedbcount'])>0)
				{
		//			echo($db_result['uforum_messagedbcount'][0]['replycount']);
					return $db_result['uforum_messagedbcount'][0]['replycount'];
				}
			}
		}
		return 0;
	}

	function getviewtimesbymsg($_request, $_response)
	{
	}

	function getposttimesbyuser($_request, $_response)
	{
		if (isset($_request['userid']))
		{
			$sqlq = new SQLSelect();
			$sqlq->setSelect($this->db_field['uforum_messagedb'],
				$this->db_table['uforum_messagedb']);
			$sqlq->setWhere($this->db_table['uforum_messagedb'].
				".userid=" . $_request['userid']);

			$sqlq->setSelectOther("COUNT(*) AS " . $this->db_table['uforum_messagedb']."count__posttimes");
			$sqlq->setGroup($this->db_table['uforum_messagedb'].
				".userid");
//echo("<p>" . $sqlq->SQLReturn() . "</p>");
			$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());

			if (isset($db_result['uforum_messagedbcount']))
			{
				if (count($db_result['uforum_messagedbcount'])>0)
				{
					return $db_result['uforum_messagedbcount'][0]['posttimes'];
				}
			}
		}
		return 0;
	}

}

?>
