<?PHP

class DAOGetStudent extends DAOControl
{

	function main($_request, $_response)
	{
		$_response['totalitemno'] = $this->count($_request, array());

		$sqlq = new SQLSelect();
		$sqlq->setSelect($this->db_field['userdb'], $this->db_table['userdb']);
		$sqlq->setSelect($this->db_field['studentprofiledb'], $this->db_table['studentprofiledb']);
		$sqlq->setSelect($this->db_field['contactdb'], $this->db_table['contactdb']);
		$sqlq->setWhere($this->db_table['userdb'] . ".id=" . $this->db_table['studentprofiledb'] . ".pid");
		$sqlq->setWhere($this->db_table['contactdb'] . ".pid=" . $this->db_table['userdb'] .".id");
		$sqlq->setOrder($this->db_table['userdb'] . ".id ASC");
		if ((isset($_request['where'])) && (is_array($_request['where'])))
		{
			@reset($_request['where']);
			foreach($_request['where'] as $key => $value)
			{
				$sqlq->setWhere($value);
			}
		} elseif (isset($_request['where'])) {
			$sqlq->setWhere($_request['where']);
		}
		if (isset($_request['sql_start']) && isset($_request['sql_limit']))
			$sqlq->setLimit($_request['sql_start'], $_request['sql_limit']);

//echo($sqlq->SQLReturn() . "<br />");
		$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());

		$_response['userdb'] = $this->populate('userdb', $this->db_table['userdb'], $db_result);
		$_response['studentprofiledb'] = $this->populate("studentprofiledb", $this->db_table['studentprofiledb'], $db_result);
		$_response['contactdb'] = $this->populate("contactdb", $this->db_table['contactdb'], $db_result);

		return $_response;
	}

	function count($_request, $_response)
	{
		$sqlq = new SQLSelect();
		$sqlq->setSelect($this->db_field['userdb'], $this->db_table['userdb']);
		$sqlq->setSelect($this->db_field['studentprofiledb'], $this->db_table['studentprofiledb']);
		$sqlq->setSelect($this->db_field['contactdb'], $this->db_table['contactdb']);
		$sqlq->setSelect($this->db_field['universitydb'], $this->db_table['universitydb']);
		$sqlq->setSelectOther("count(*) AS " . $this->db_table['userdb'] . "__totalno");
		$sqlq->setWhere($this->db_table['userdb'] . ".id=" . $this->db_table['studentprofiledb'] . ".pid");
		$sqlq->setWhere($this->db_table['contactdb'] . ".pid=" . $this->db_table['userdb'] .".id");
		$sqlq->setWhere($this->db_table['studentprofiledb'] . ".school=" . $this->db_table['universitydb'] . ".id");
		$sqlq->setOrder($this->db_table['userdb'] . ".id ASC");
		if ((isset($_request['where'])) && (is_array($_request['where'])))
		{
			@reset($_request['where']);
			foreach($_request['where'] as $key => $value)
			{
				$sqlq->setWhere($value);
			}
		} elseif (isset($_request['where'])) {
			$sqlq->setWhere($_request['where']);
		}
		$sqlq->setGroup($this->db_table['userdb'] . ".acctype");
//echo($sqlq->SQLReturn() . "<br />");
		$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());

		//$_response['userdb'] = $this->populate('userdb', $this->db_table['userdb'], $db_result);
		//$_response['studentprofiledb'] = $this->populate("studentprofiledb", $this->db_table['studentprofiledb'], $db_result);
		//$_response['contactdb'] = $this->populate("contactdb", $this->db_table['contactdb'], $db_result);
		//$_response['universitydb'] = $this->populate("universitydb", $this->db_table['universitydb'], $db_result);

		if (isset($db_result['userdb']) && isset($db_result['userdb'][0]))
		{
			return $db_result['userdb'][0]['totalno'];
		}
		//return $_response;
	}

	function getUserbylogin($_loginname)
	{
		$request = array();

		$sqlq = new SQLSelect();
		$sqlq->setSelect($this->db_field['userdb'], $this->db_table['userdb']);
		$sqlq->setWhere($this->db_table['userdb'].".username='" . $_loginname . "'");

		$db_result = $sqlq->getRow($this->db, $sqlq->SQLReturn());
		$_response['userdb'] = $this->populate('userdb', $this->db_table['userdb'], $db_result);

		return $_response;
	}


	function getUserbyid($_id)
	{
		$request = array();
		$request['where'] = $this->db_table['userdb'].".id=" . $_id . "";
		$response = $this->main($request, array());

		return $response;
	}

	function getUserbyEmail($_email)
	{
		$request = array();
		$request['where'] = $this->db_table['contactdb'].".email='" . $_email . "'";
		$response = $this->main($request, array());

		return $response;
	}

	function getUserbyStatus($_status)
	{
		$request = array();
		$request['where'] = $this->db_table['userdb'].".status=" . $_status;
		$response = $this->main($request, array());

		return $response;
	}
}

?>
